USBHIDACTION(1) | General Commands Manual | USBHIDACTION(1)

# NAME

usbhidaction — perform actions according to USB HID controls

# SYNOPSIS

usbhidaction | -c config-file [-d] [-i] -f device [-t table] [-v] [arg ...]

# DESCRIPTION

usbhidaction can be used to execute commands when certain values appear on HID controls. The normal operation for this program is to read the configuration file and then become a daemon and execute commands as the HID items specify. If a read from the HID device fails the program dies; this will make it die when the USB device is unplugged.

The options are as follows:

-c config-file
  Specify a path name for the config file. When running as a daemon this needs to be an absolute path for the HUP signal to work.
-d
  Toggle the daemon flag.
-i
  Ignore HID items in the config file that do not exist in the device.
-f device
  Specify a path name for the device to operate on. If device is numeric, it is taken to be the USB HID device number. If it is a relative path, it is taken to be the name of the device under /dev. An absolute path is taken to be the literal device pathname.
-t table
  Specify a path name for the HID usage table file.
-v
  Be verbose, and do not become a daemon.

The config file will be re-read if the process gets a HUP signal.

# CONFIGURATION

The configuration file has a very simple format. Each line describes an action; if a line begins with a whitespace it is considered a continuation of the previous line. Lines beginning with `#' are considered as comments.

Each line has three parts: a name of a USB HID item, a value for that item, and an action. There must be whitespace between the parts.

The item names are similar to those used by usbhidctl(1), but each part must be prefixed by its page name (use the -v flag to usbhidctl(1) to see the page name). Replace spaces in the item name by underscores.

The value is simply a numeric value. When the item reports this value the action will be performed. If the value is `*' it will match any value.

The action is a normal command that is executed with system(3). Before it is executed some substitution will occur: `$n' will be replaced by the nth argument on the command line, `$V' will be replaced by the numeric value of the HID item, `$N' will be replaced by the name of the control, and `$H' will be replaced by the name of the HID device.

# FILES

/usr/share/misc/usb_hid_usages The HID usage table.

# EXAMPLES

The following configuration file can be used to control a pair of Philips USB speakers with the HID controls on the speakers.

    # Configuration for various Philips USB speakers
    Consumer:Consumer_Control.Consumer:Volume_Up			   1
    	mixerctl -f $1 -n -w outputs.master++
    Consumer:Consumer_Control.Consumer:Volume_Down			   1
    	mixerctl -f $1 -n -w outputs.master--
    Consumer:Consumer_Control.Consumer:Mute				   1
    	mixerctl -f $1 -n -w outputs.mute++
    Consumer:Consumer_Control.Consumer:Channel_Top.Microsoft:Base_Up   1
    	mixerctl -f $1 -n -w outputs.bass++
    Consumer:Consumer_Control.Consumer:Channel_Top.Microsoft:Base_Down 1
    	mixerctl -f $1 -n -w outputs.bass--

A sample invocation using this configuration would be

    usbhidaction -f /dev/uhid1 -c conf /dev/mixer1

This configuration file can be used for various keyboards with extra keys:

    # Configuration for extra keyboard keys
    Consumer:Consumer_Control.Consumer:Volume_Up			1
    	mixerctl -n -w outputs.master++
    Consumer:Consumer_Control.Consumer:Volume_Down			1
    	mixerctl -n -w outputs.master--
    Consumer:Consumer_Control.Consumer:Mute				1
    	mixerctl -n -w outputs.mute++
    Consumer:Consumer_Control.Consumer:Pause/Play			1
    	xmms -p
    Consumer:Consumer_Control.Consumer:Stop				1
    	xmms -s
    Consumer:Consumer_Control.Consumer:Scan_Previous_Track		1
    	xmms -r
    Consumer:Consumer_Control.Consumer:Scan_Next_Track		1
    	xmms -f

And this configuration can be used with, e.g.,

    usbhidaction -f /dev/uhid0 -c conf -i

# SEE ALSO

usbhidctl(1), usbhid(3), uhid(4), usb(4)

# HISTORY

The usbhidaction command first appeared in NetBSD 1.6.

October 20, 2004 | NetBSD 6.0